#*************************************************************************************************************
# Programm PYBALKEN
# 21.12.2020 Rieg
# 2.5.2021 Rieg: Zeile 178 geaendert
#*************************************************************************************************************
ti= False      # True fuer TI-Nspire, False fuer PC

if ti == True:
  from ti_system import clear_history
from math import pi

#***********************************************************************
#  nint
#*********************************************************************** 
def nint(a):
  mk= round(a)
  return (mk)

#***********************************************************************
#  Function plus
#*********************************************************************** 
def plus():
  global r
  global puf1,puf2

  r[14]=r[13]/r[14] 

  for i in range(1,4):
    r[1]+= r[2]*r[13] 
    r[2]+= r[3]*r[14] 
    r[1]+= r[3]*r[14]*r[13]/2 
    r[3]+= r[4]*r[13] 
    r[2]+= r[4]*r[13]*r[14]/2 
    r[1]+= r[4]*r[13]*r[14]/2*r[13]/3 

    puf1=  r[5] 
    r[5]=  r[1] 
    puf2=  r[9] 
    r[9]=  puf1 
    r[1]=  puf2 

    puf1=  r[6] 
    r[6]=  r[2] 
    puf2=  r[10] 
    r[10]= puf1 
    r[2]=  puf2 

    puf1=  r[7] 
    r[7]=  r[3] 
    puf2=  r[11] 
    r[11]= puf1 
    r[3]=  puf2 

    puf1=  r[8] 
    r[8]=  r[4] 
    puf2=  r[12] 
    r[12]= puf1 
    r[4]=  puf2 

#***********************************************************************
#  Function streck
#*********************************************************************** 
def streck():
  global r,q,qs

  q=  float(input("q=q links= "))
  qs= float(input("qs=Steigung von q= "))

  r[4]+= -q*r[13] 
  r[3]+= -q*r[13]*r[13]/2 
  r[2]+= -q*r[13]*r[13]/2*r[14]/3 
  r[1]+= -q*r[13]*r[13]/2*r[14]/3*r[13]/4 

  r[4]+= -qs*r[13]*r[13]/2 
  r[3]+= -qs*r[13]*r[13]/2*r[13]/3 
  r[2]+= -qs*r[13]*r[13]/2*r[13]/3*r[14]/4 
  r[1]+= -qs*r[13]*r[13]/2*r[13]/3*r[14]/4*r[13]/5

#***********************************************************************
#  Function re
#*********************************************************************** 
def re():
  global r,s2,w2,ip,puf1

  print("rechtes Traegerende:")
  print("gel.Lager:S2=3(M),W2=0/M")
  print("freies E.:S2=4(Q),W2=0/Q")
  print("Einspann.:S2=2(p),W2=0")

  s2= int(input("S2= "))
  w2= float(input("W2= "))

  r[14]= s2 
  ip= nint(r[14]) 
  puf1= r[ip] 
  r[14]+= 4 
  ip= nint(r[14]) 
  r[16]= (puf1-w2)/r[ip] 

#*************************************************************************************************************
# Function choice
#*************************************************************************************************************
def choice():
  global ikey
  
  if ti == True:
    clear_history()
  
  while True:
    print()
    print("Durchlauftraeger,9 Info")
    print("1 linkes Traegerende")
    print("2 Z-Bed. elast.Lager")
    print("3 Traegerabschnitt")
    print("4 Einzellast")
    print("5 Wellenabschnitt")
    print("6 Lager,Gelenk,re.Ende")
    print("7 w, psi, M, Q")
    print("8 Exit")

    key= input("Ihre Wahl: ")
    if key in ("1","2","3","4","5","6","7","8","9"):
      break
    
  ikey= int(key)
  key= " "

#**********************************************************************
# Hauptprogramm
#**********************************************************************
choice()

#----------------------------------------------------------------------
#  Startwerte
#----------------------------------------------------------------------
r=[0.0]*32

c= l= ei= puf1= puf2= puf3= q= qs= last= 0.0
e= d= w1= w2= w= psi= m= 0.0

i= s1= s2= ip= jp= iq0= p0= ire= 0

#----------------------------------------------------------------------
#Endlos-Schleife
#----------------------------------------------------------------------
while True:

#----------------------------------------------------------------------
# i Info
#----------------------------------------------------------------------
  if ikey == 9:
    if ti == True:
      clear_history()
    print()
    print("PYBALKEN,Lehrstuhl Konstruktionslehre + CAD,Universitaet Bayreuth\
 Prof.Dr.-Ing.Frank Rieg,2.5.2021,basiert auf einem TI59 Programm von\
 Prof.O.Ewald u. Dipl.Ing.F.Merlino")
    key=input("weiter mit Enter-Taste")
    choice()
  
#----------------------------------------------------------------------
#  1 linkes Traegerende
#----------------------------------------------------------------------
  if ikey == 1:
    if ti == True:
      clear_history()
    print()

    for i in range(1,13):
      r[i]=0.0

    print("linkes Traegerende")
    print("unbekannt sind S1 u. S2")
    print("gel.Lager:S1=2(p),S2=4(Q)")
    print("freies E.:S1=1(w),S2=2(p)")
    print("Einspann.:S1=3(M),S2=4(Q)")
    s1= int(input("S1= "))
    s2= int(input("S2= "))
    r[13]= s1+4 
    r[14]= s2+8   
    ip=nint(r[13]) 
    r[ip]= 1 
    ip=nint(r[14]) 
    r[ip]= 1 
    r[15]= 20 

    choice()

#----------------------------------------------------------------------
#  2 elastisches Auflager
#----------------------------------------------------------------------
  if ikey == 2:
    if ti == True:
      clear_history()
    print()

    print("Z-Bed.:elast.Auflager")
    print("mit c Federsteifigkeit")
    c= float(input("c= "))
    r[13] = c 
    r[4] += c*r[1]   
    r[8] += c*r[5]  
    r[12]+= c*r[9] 

    choice()

#----------------------------------------------------------------------
#  3 Traegerabschnitt
#----------------------------------------------------------------------
  if ikey == 3:
    if ti == True:
      clear_history()
    print()

    print("Traegerabschnitt")
    l= float(input("Laenge= "))
    ei= float(input("Biegesteifigk.EI= "))
    r[13]= l 
    r[14]= -ei   

    plus()
  
    iq0= int(input("Streckenlast?1=ja 0=no: "))

    if(iq0 == 1):
      streck()

    choice()

#----------------------------------------------------------------------
#  4 Einzellasten
#---------------------------------------------------------------------- 
  if ikey == 4:
    if ti == True:
      clear_history()
    print()

    print("Einzellasten")
    print("Kraft :S1=4(Q),Last=F")
    print("Moment:S1=3(M),Last=M")
    print("Winkel:S1=2(p),Last=p")
    print("Absen.:S1=1(w),Last=w")
    s1= int(input("S1= "))
    last= float(input("Last= "))
    p0= s1 
    r[p0]-= last  

    choice()

#----------------------------------------------------------------------
#  5 Wellenabschnitt
#---------------------------------------------------------------------- 
  if ikey == 5:
    if ti == True:
      clear_history()
    print()

    print("Wellenabschnitt")
    l= float(input("Laenge = ")) 
    e= float(input("E-Modul= ")) 
    d= float(input("Durchm.= ")) 
    r[13]= l 
    r[14]= -e*pi*(d**4.)/64.

    plus()
  
    iq0= int(input("Streckenlast?1=ja 0=no: "))

    if iq0 == 1:
      streck()

    choice()

#----------------------------------------------------------------------
#  6 Zwischenbedingung
#---------------------------------------------------------------------- 
  if ikey == 6:
    if ti == True:
      clear_history()
    print()

    print("Zwischenbedingung")
    print("gel.Lager:S1=1(w),W1=0")
    print("Gelenk:   S1=3(M),W1=0")
    print("rechtes Traegerende:")
    print("gel.Lager:S1=1(w),W1=0")
    print("freies E.:S1=3(M),W1=Wert")
    print("Einspann.:S1=1(w),W1=0")

    s1= int(input("S1= "))
    w1= float(input("W1= "))

    r[14]=  s1  
    r[17]=  r[14]+8 
    r[18]=  w1 
    ip= nint(r[14]) 
    r[ip]+= -r[18] 
  
    for i in range(1,3,1):
      ip= nint(r[14]) 
      jp= nint(r[17]) 
      r[13]= -r[ip]/r[jp] 
      ip= nint(r[15]) 
      r[ip]= r[13] 
      ip= nint(r[15]) 
      puf1=  r[ip]*r[9] 
      puf2=  r[5] 
      r[5]=  puf1 
      puf3=  r[1] 
      r[1]=  puf2 
      r[5]+= puf3 

      puf1=  r[13]*r[10] 
      puf2=  r[6] 
      r[6]=  puf1 
      puf3=  r[2] 
      r[2]=  puf2 
      r[6]+= puf3 

      puf1=  r[13]*r[11] 
      puf2=  r[7] 
      r[7]=  puf1 
      puf3=  r[3] 
      r[3]=  puf2 
      r[7]+= puf3 

      puf1=  r[13]*r[12] 
      puf2=  r[8] 
      r[8]=  puf1 
      puf3=  r[4] 
      r[4]=  puf2 
      r[8]+= puf3 

      r[15]+=1
    
    ip= nint(r[14]) 
    r[ip]= r[18] 
    r[9] = 0. 
    r[10]= 0. 
    r[11]= 0. 
    r[12]= 0. 
    r[14]= 13-r[14] 
    ip= nint(r[14]) 
    r[ip]= 1. 

    ire= int(input("rechtes Ende?1=ja 0=no:"))
  
    if ire == 1:
      if ti == True:
        clear_history()
      print()
      re()

    choice()

#----------------------------------------------------------------------
#  7 Ergebnisse
#---------------------------------------------------------------------- 
  if ikey == 7:
    if ti == True:
      clear_history()
    print()

    print("Ergebnisse:")
    p0= r[15]+1 
    ip= nint(r[15])
    r[14]= r[16]*r[p0]-r[ip] 
    w=   r[1]-r[16]*r[5]-r[14]*r[9] 
    psi= r[2]-r[16]*r[6]-r[14]*r[10] 
    m=   r[3]-r[16]*r[7]-r[14]*r[11] 
    q=   r[4]-r[16]*r[8]-r[14]*r[12] 

    print("w  = {0:.5e}".format(w)) 
    print("psi= {0:.5e}".format(psi)) 
    print("M= {0:.5e}".format(m)) 
    print("Q= {0:.5e}".format(q)) 

    key=input("weiter mit Enter-Taste")
    choice()

#----------------------------------------------------------------------
#  F8 Exit
#----------------------------------------------------------------------
  if ikey == 8:
    print("Ende PYBALKEN")
    break


